part of swagger.api;



class AuthAPIApi {
  final ApiClient apiClient;

  AuthAPIApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Получить ключ доступа
  ///
  /// Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр &#39;token&#39;). Для вычисления значения параметра &#39;response&#39; необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&amp;nbsp;+&amp;nbsp;salt&amp;nbsp;+&amp;nbsp;&#39;\\n&#39;))
  Future<String> authLoginPost(String login, String salt, String response,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(login == null) {
     throw new ApiException(400, "Missing required param: login");
    }
    if(salt == null) {
     throw new ApiException(400, "Missing required param: salt");
    }
    if(response == null) {
     throw new ApiException(400, "Missing required param: response");
    }

    // create path and map variables
    String path = "/auth/login".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != login) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "login", login));
    }
    if("null" != salt) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "salt", salt));
    }
    if("null" != response) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "response", response));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Получить соль
  ///
  /// Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
  Future<String> authStartGet(String login,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(login == null) {
     throw new ApiException(400, "Missing required param: login");
    }

    // create path and map variables
    String path = "/auth/start".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != login) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "login", login));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
}
