part of swagger.api;



class DefaultApi {
  final ApiClient apiClient;

  DefaultApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Аккаунт: баланс
  ///
  /// Возвращает текущий баланс аккаунта
  Future<Number> balanceGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/balance".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'Number') ;
    } else {
      return null;
    }
  }
  /// Аккаунт: баланс аккаунта лицензий
  ///
  /// Возвращает текущий баланс аккаунта лицензий
  Future<Number> balanceLicGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/balance.lic".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'Number') ;
    } else {
      return null;
    }
  }
  /// Информация по дебету аккаунта
  ///
  /// Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
  Future<List<InlineResponse200>> billingDebtGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/billing/debt".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse200>') ;
    } else {
      return null;
    }
  }
  /// Информация об аккаунте
  ///
  /// Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
  Future<List<InlineResponse2001>> billingInfoGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/billing/info".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse2001>') ;
    } else {
      return null;
    }
  }
  /// Получить ограничения аккаунта
  ///
  /// 
  Future< > billingLimitsGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/billing/limits".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, ' ') ;
    } else {
      return null;
    }
  }
  /// Информация по продлению доменов
  ///
  /// 
  Future<List<InlineResponse2004>> dnsProlongListGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/dns/prolong/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse2004>') ;
    } else {
      return null;
    }
  }
  /// Создание почтового ящика
  ///
  /// 
  Future<String> emailAddGet(String token_, String addEmail,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(addEmail == null) {
     throw new ApiException(400, "Missing required param: addEmail");
    }

    // create path and map variables
    String path = "/email/add".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != addEmail) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "add_email", addEmail));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Удаление псевдонимов почтовых ящиков
  ///
  /// 
  Future<String> emailAliasDeleteGet(String token_, String key_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/email/alias/delete".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Получить список псевдонимов почтовых ящиков
  ///
  /// 
  Future<List<InlineResponse2005>> emailAliasListGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/email/alias/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse2005>') ;
    } else {
      return null;
    }
  }
  /// Удаление почтового ящика
  ///
  /// 
  Future<String> emailDeleteGet(String token_, String key_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/email/delete".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Получить список почтовых ящиков
  ///
  /// 
  Future<List<InlineResponse2006>> emailListGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/email/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse2006>') ;
    } else {
      return null;
    }
  }
  /// Идентификатор последнего уведомления в аудите
  ///
  /// 
  Future<int> updatesLastGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/updates/last".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'int') ;
    } else {
      return null;
    }
  }
  /// Список записей аудита
  ///
  /// 
  Future<List<InlineResponse20010>> updatesListGet(String token_, int key_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/updates/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse20010>') ;
    } else {
      return null;
    }
  }
  /// Удаление сайта
  ///
  /// 
  Future<String> websiteDeleteGet(String token_, String key_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/website/delete".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Список сайтов аккаунта
  ///
  /// 
  Future<List<InlineResponse20014>> websiteListGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/website/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse20014>') ;
    } else {
      return null;
    }
  }
}
