part of swagger.api;



class DNSApi {
  final ApiClient apiClient;

  DNSApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Создание записи домена
  ///
  /// 
  Future<String> dnsAddGet(String token_, String addDnsZone,  {  String addDnsRecord,  String iisSiteForDns,  bool bindOnly,  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(addDnsZone == null) {
     throw new ApiException(400, "Missing required param: addDnsZone");
    }

    // create path and map variables
    String path = "/dns/add".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != addDnsZone) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "add_dns_zone", addDnsZone));
    }
    if("null" != addDnsRecord) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "add_dns_record", addDnsRecord));
    }
    if("null" != iisSiteForDns) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "iis_site_for_dns", iisSiteForDns));
    }
    if("null" != bindOnly) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "bind_only", bindOnly));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Привязка одного домена к другому
  ///
  /// 
  Future<String> dnsBindGet(String token_, int key_,  {  String bindTo,  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/dns/bind".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    if("null" != bindTo) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "bind_to", bindTo));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Получить список доменных имён
  ///
  /// 
  Future<List<InlineResponse2003>> dnsListGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/dns/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse2003>') ;
    } else {
      return null;
    }
  }
  /// Информация по продлению доменов
  ///
  /// 
  Future<List<InlineResponse2004>> dnsProlongListGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/dns/prolong/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse2004>') ;
    } else {
      return null;
    }
  }
  /// Редактирование \&quot;сырой\&quot; зоны
  ///
  /// 
  Future<String> dnsRawGet(String token_, int key_, int sDel, int sAdd, String dnsType, String dnsName, String dnsValue,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }
    if(sDel == null) {
     throw new ApiException(400, "Missing required param: sDel");
    }
    if(sAdd == null) {
     throw new ApiException(400, "Missing required param: sAdd");
    }
    if(dnsType == null) {
     throw new ApiException(400, "Missing required param: dnsType");
    }
    if(dnsName == null) {
     throw new ApiException(400, "Missing required param: dnsName");
    }
    if(dnsValue == null) {
     throw new ApiException(400, "Missing required param: dnsValue");
    }

    // create path and map variables
    String path = "/dns/raw".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    if("null" != sDel) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "s_del", sDel));
    }
    if("null" != sAdd) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "s_add", sAdd));
    }
    if("null" != dnsType) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "dns_type", dnsType));
    }
    if("null" != dnsName) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "dns_name", dnsName));
    }
    if("null" != dnsValue) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "dns_value", dnsValue));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Редактировать DNS-зону
  ///
  /// 
  Future<String> dnsRawManagedmxGet(String token_, int key_, int managedMx, int updManagedMx,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }
    if(managedMx == null) {
     throw new ApiException(400, "Missing required param: managedMx");
    }
    if(updManagedMx == null) {
     throw new ApiException(400, "Missing required param: updManagedMx");
    }

    // create path and map variables
    String path = "/dns/raw/managedmx".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    if("null" != managedMx) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "managed_mx", managedMx));
    }
    if("null" != updManagedMx) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "upd_managed_mx", updManagedMx));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
}
