part of swagger.api;



class VDSHyperVOpenVZApi {
  final ApiClient apiClient;

  VDSHyperVOpenVZApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Изменение параметров VDS
  ///
  /// Изменение параметров уже существующего VDS
  Future<String> vdsCreateGet(String token_,  {  String type,  int crHvmem,  int crHvdsk,  int crHvcpu,  String template,  String forceMemo,  String hv1gbPanelVersion,  bool panelInstall,  bool crSsd1,  bool crHvAllSystem,  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/vds/create".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != type) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "type", type));
    }
    if("null" != crHvmem) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_hvmem", crHvmem));
    }
    if("null" != crHvdsk) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_hvdsk", crHvdsk));
    }
    if("null" != crHvcpu) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_hvcpu", crHvcpu));
    }
    if("null" != template) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "template", template));
    }
    if("null" != forceMemo) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "force_memo", forceMemo));
    }
    if("null" != hv1gbPanelVersion) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "hv_1gb_panel_version", hv1gbPanelVersion));
    }
    if("null" != panelInstall) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "panel_install", panelInstall));
    }
    if("null" != crSsd1) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_ssd1", crSsd1));
    }
    if("null" != crHvAllSystem) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_hv_all_system", crHvAllSystem));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Удаление VDS
  ///
  /// Предоставляет функционал для удаления VDS
  Future<String> vdsDeleteGet(String token_, int key_,  {  bool forceCritical,  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/vds/delete".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    if("null" != forceCritical) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "force_critical", forceCritical));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Добавление IP на VDS
  ///
  /// Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
  Future<String> vdsIpAddGet(String token_, int key_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/vds/ip/add".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Удаление IP с VDS
  ///
  /// Этот вызов позволяет отвязать IP адрес от VDS
  Future<String> vdsIpDeleteGet(String token_, int key_, String delIp,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }
    if(delIp == null) {
     throw new ApiException(400, "Missing required param: delIp");
    }

    // create path and map variables
    String path = "/vds/ip/delete".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    if("null" != delIp) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "del_ip", delIp));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Список IP-адресов виртуальных серверов
  ///
  /// Список IP-адресов виртуальных серверов
  Future<List<InlineResponse20011>> vdsIpListGet(String token_,  {  int key_,  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/vds/ip/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse20011>') ;
    } else {
      return null;
    }
  }
  /// Список виртуальных серверов
  ///
  /// Позволяет получить список виртуальных серверов
  Future<List<InlineResponse20012>> vdsListGet(String token_,  {  int key_,  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/vds/list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse20012>') ;
    } else {
      return null;
    }
  }
  /// Перезагрузка VDS
  ///
  /// Предоставляет функционал для перезагрузки VDS
  Future<String> vdsRebootGet(String token_, int key_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/vds/reboot".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
  /// Список шаблонов виртуальных серверов
  ///
  /// Позволяет получить список шаблонов виртуальных серверов
  Future<List<InlineResponse20013>> vdsTemplatesListGet(String token_,  {  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }

    // create path and map variables
    String path = "/vds/templates-list".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'List<InlineResponse20013>') ;
    } else {
      return null;
    }
  }
  /// Создание VDS
  ///
  /// Создание новых VDS с произвольными характеристиками
  Future<String> vdsUpdateGet(String token_, int key_,  {  int crHvmem,  int crHvdsk,  int crHvcpu,  bool justIgnoreThisFlag: true}) async {
    if (!justIgnoreThisFlag) {
      print('Why???   Just trust me, I only need this variable inside the mustache codegen template.');
      // This code may be removed as soon as dart accepts trailing spaces (has already been implemented).
    }
    Object postBody = null;

    // verify required params are set
    if(token_ == null) {
     throw new ApiException(400, "Missing required param: token_");
    }
    if(key_ == null) {
     throw new ApiException(400, "Missing required param: key_");
    }

    // create path and map variables
    String path = "/vds/update".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if("null" != token_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_token_", token_));
    }
    if("null" != key_) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "_key_", key_));
    }
    if("null" != crHvmem) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_hvmem", crHvmem));
    }
    if("null" != crHvdsk) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_hvdsk", crHvdsk));
    }
    if("null" != crHvcpu) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "cr_hvcpu", crHvcpu));
    }
    
    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = [];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return  apiClient.deserialize(response.body, 'String') ;
    } else {
      return null;
    }
  }
}
